make fetch
[autoconf.git] / maint.mk
blobc462d24608b3de5211aa7056e4e04e4802524783
1 # -*-Makefile-*-
2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by many projects via the gnulib maintainer-makefile module.
5 ## Copyright (C) 2001-2017 Free Software Foundation, Inc.
6 ##
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 ## GNU General Public License for more details.
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program. If not, see <https://www.gnu.org/licenses/>.
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22 ME := maint.mk
24 # Helper variables.
25 _empty =
26 _sp = $(_empty) $(_empty)
28 # _equal,S1,S2
29 # ------------
30 # If S1 == S2, return S1, otherwise the empty string.
31 _equal = $(and $(findstring $(1),$(2)),$(findstring $(2),$(1)))
33 # member-check,VARIABLE,VALID-VALUES
34 # ----------------------------------
35 # Check that $(VARIABLE) is in the space-separated list of VALID-VALUES, and
36 # return it. Die otherwise.
37 member-check = \
38 $(strip \
39 $(if $($(1)), \
40 $(if $(findstring $(_sp),$($(1))), \
41 $(error invalid $(1): '$($(1))', expected $(2)), \
42 $(or $(findstring $(_sp)$($(1))$(_sp),$(_sp)$(2)$(_sp)), \
43 $(error invalid $(1): '$($(1))', expected $(2)))), \
44 $(error $(1) undefined)))
46 # Do not save the original name or timestamp in the .tar.gz file.
47 # Use --rsyncable if available.
48 gzip_rsyncable := \
49 $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \
50 && printf %s --rsyncable)
51 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
53 GIT = git
54 VC = $(GIT)
56 VC_LIST = $(srcdir)/$(_build-aux)/vc-list-files -C $(srcdir)
58 # You can override this variable in cfg.mk if your gnulib submodule lives
59 # in a different location.
60 gnulib_dir ?= $(srcdir)/gnulib
62 # You can override this variable in cfg.mk to set your own regexp
63 # matching files to ignore.
64 VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
66 # This is to preprocess robustly the output of $(VC_LIST), so that even
67 # when $(srcdir) is a pathological name like "....", the leading sed command
68 # removes only the intended prefix.
69 _dot_escaped_srcdir = $(subst .,\.,$(srcdir))
71 # Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
72 # when $(srcdir) is not ".".
73 ifeq ($(srcdir),.)
74 _prepend_srcdir_prefix =
75 else
76 _prepend_srcdir_prefix = | $(SED) 's|^|$(srcdir)/|'
77 endif
79 # In order to be able to consistently filter "."-relative names,
80 # (i.e., with no $(srcdir) prefix), this definition is careful to
81 # remove any $(srcdir) prefix, and to restore what it removes.
82 _sc_excl = \
83 $(or $(exclude_file_name_regexp--$@),^$$)
84 VC_LIST_EXCEPT = \
85 $(VC_LIST) | $(SED) 's|^$(_dot_escaped_srcdir)/||' \
86 | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
87 else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
88 | grep -Ev -e '($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
89 $(_prepend_srcdir_prefix)
91 ifeq ($(origin prev_version_file), undefined)
92 prev_version_file = $(srcdir)/.prev-version
93 endif
95 PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
96 VERSION_REGEXP = $(subst .,\.,$(VERSION))
97 PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
99 ifeq ($(VC),$(GIT))
100 this-vc-tag = v$(VERSION)
101 this-vc-tag-regexp = v$(VERSION_REGEXP)
102 else
103 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
104 tag-this-version = $(subst .,_,$(VERSION))
105 this-vc-tag = $(tag-package)-$(tag-this-version)
106 this-vc-tag-regexp = $(this-vc-tag)
107 endif
108 my_distdir = $(PACKAGE)-$(VERSION)
110 # Old releases are stored here.
111 release_archive_dir ?= ../release
113 # If RELEASE_TYPE is undefined, but RELEASE is, use its second word.
114 # But overwrite VERSION.
115 ifdef RELEASE
116 VERSION := $(word 1, $(RELEASE))
117 RELEASE_TYPE ?= $(word 2, $(RELEASE))
118 endif
120 # Validate and return $(RELEASE_TYPE), or die.
121 RELEASE_TYPES = alpha beta stable
122 release-type = $(call member-check,RELEASE_TYPE,$(RELEASE_TYPES))
124 # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
125 # Use alpha.gnu.org for alpha and beta releases.
126 # Use ftp.gnu.org for stable releases.
127 gnu_ftp_host-alpha = alpha.gnu.org
128 gnu_ftp_host-beta = alpha.gnu.org
129 gnu_ftp_host-stable = ftp.gnu.org
130 gnu_rel_host ?= $(gnu_ftp_host-$(release-type))
132 url_dir_list ?= $(if $(call _equal,$(gnu_rel_host),ftp.gnu.org), \
133 https://ftpmirror.gnu.org/$(PACKAGE), \
134 https://$(gnu_rel_host)/gnu/$(PACKAGE))
136 # Override this in cfg.mk if you are using a different format in your
137 # NEWS file.
138 today = $(shell date +%Y-%m-%d)
140 # Select which lines of NEWS are searched for $(news-check-regexp).
141 # This is a sed line number spec. The default says that we search
142 # lines 1..10 of NEWS for $(news-check-regexp).
143 # If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
144 news-check-lines-spec ?= 1,10
145 news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
147 # Prevent programs like 'sort' from considering distinct strings to be equal.
148 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
149 export LC_ALL = C
151 ## --------------- ##
152 ## Sanity checks. ##
153 ## --------------- ##
155 ifneq ($(_gl-Makefile),)
156 _cfg_mk := $(wildcard $(srcdir)/cfg.mk)
158 # Collect the names of rules starting with 'sc_'.
159 syntax-check-rules := $(sort $(shell $(SED) -n \
160 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' $(srcdir)/$(ME) $(_cfg_mk)))
161 .PHONY: $(syntax-check-rules)
163 ifeq ($(shell $(VC_LIST) >/dev/null 2>&1; echo $$?),0)
164 local-checks-available += $(syntax-check-rules)
165 else
166 local-checks-available += no-vc-detected
167 no-vc-detected:
168 @echo "No version control files detected; skipping syntax check"
169 endif
170 .PHONY: $(local-checks-available)
172 # Arrange to print the name of each syntax-checking rule just before running it.
173 $(syntax-check-rules): %: %.m
174 sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
175 .PHONY: $(sc_m_rules_)
176 $(sc_m_rules_):
177 @echo $(patsubst sc_%.m, %, $@)
178 @date +%s.%N > .sc-start-$(basename $@)
180 # Compute and print the elapsed time for each syntax-check rule.
181 sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
182 .PHONY: $(sc_z_rules_)
183 $(sc_z_rules_): %.z: %
184 @end=$$(date +%s.%N); \
185 start=$$(cat .sc-start-$*); \
186 rm -f .sc-start-$*; \
187 awk -v s=$$start -v e=$$end \
188 'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
190 # The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
191 # that computes and prints elapsed time.
192 local-check := \
193 $(patsubst sc_%, sc_%.z, \
194 $(filter-out $(local-checks-to-skip), $(local-checks-available)))
196 syntax-check: $(local-check)
197 endif
199 # _sc_search_regexp
201 # This macro searches for a given construct in the selected files and
202 # then takes some action.
204 # Parameters (shell variables):
206 # prohibit | require
208 # Regular expression (ERE) denoting either a forbidden construct
209 # or a required construct. Those arguments are exclusive.
211 # exclude
213 # Regular expression (ERE) denoting lines to ignore that matched
214 # a prohibit construct. For example, this can be used to exclude
215 # comments that mention why the nearby code uses an alternative
216 # construct instead of the simpler prohibited construct.
218 # in_vc_files | in_files
220 # grep-E-style regexp selecting the files to check. For in_vc_files,
221 # the regexp is used to select matching files from the list of all
222 # version-controlled files; for in_files, it's from the names printed
223 # by "find $(srcdir)". When neither is specified, use all files that
224 # are under version control.
226 # containing | non_containing
228 # Select the files (non) containing strings matching this regexp.
229 # If both arguments are specified then CONTAINING takes
230 # precedence.
232 # with_grep_options
234 # Extra options for grep.
236 # ignore_case
238 # Ignore case.
240 # halt
242 # Message to display before to halting execution.
244 # Finally, you may exempt files based on an ERE matching file names.
245 # For example, to exempt from the sc_space_tab check all files with the
246 # .diff suffix, set this Make variable:
248 # exclude_file_name_regexp--sc_space_tab = \.diff$
250 # Note that while this functionality is mostly inherited via VC_LIST_EXCEPT,
251 # when filtering by name via in_files, we explicitly filter out matching
252 # names here as well.
254 # Initialize each, so that envvar settings cannot interfere.
255 export require =
256 export prohibit =
257 export exclude =
258 export in_vc_files =
259 export in_files =
260 export containing =
261 export non_containing =
262 export halt =
263 export with_grep_options =
265 # By default, _sc_search_regexp does not ignore case.
266 export ignore_case =
267 _ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
269 define _sc_say_and_exit
270 dummy=; : so we do not need a semicolon before each use; \
271 { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
272 endef
274 define _sc_search_regexp
275 dummy=; : so we do not need a semicolon before each use; \
277 : Check arguments; \
278 test -n "$$prohibit" && test -n "$$require" \
279 && { msg='Cannot specify both prohibit and require' \
280 $(_sc_say_and_exit) } || :; \
281 test -z "$$prohibit" && test -z "$$require" \
282 && { msg='Should specify either prohibit or require' \
283 $(_sc_say_and_exit) } || :; \
284 test -z "$$prohibit" && test -n "$$exclude" \
285 && { msg='Use of exclude requires a prohibit pattern' \
286 $(_sc_say_and_exit) } || :; \
287 test -n "$$in_vc_files" && test -n "$$in_files" \
288 && { msg='Cannot specify both in_vc_files and in_files' \
289 $(_sc_say_and_exit) } || :; \
290 test "x$$halt" != x \
291 || { msg='halt not defined' $(_sc_say_and_exit) }; \
293 : Filter by file name; \
294 if test -n "$$in_files"; then \
295 files=$$(find $(srcdir) | grep -E "$$in_files" \
296 | grep -Ev '$(_sc_excl)'); \
297 else \
298 files=$$($(VC_LIST_EXCEPT)); \
299 if test -n "$$in_vc_files"; then \
300 files=$$(echo "$$files" | grep -E "$$in_vc_files"); \
301 fi; \
302 fi; \
304 : Filter by content; \
305 test -n "$$files" && test -n "$$containing" \
306 && { files=$$(grep -l "$$containing" $$files); } || :; \
307 test -n "$$files" && test -n "$$non_containing" \
308 && { files=$$(grep -vl "$$non_containing" $$files); } || :; \
310 : Check for the construct; \
311 if test -n "$$files"; then \
312 if test -n "$$prohibit"; then \
313 grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
314 | grep -vE "$${exclude:-^$$}" \
315 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
316 else \
317 grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
318 | grep . \
319 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
320 fi \
321 else :; \
322 fi || :;
323 endef
325 sc_avoid_if_before_free:
326 @$(srcdir)/$(_build-aux)/useless-if-before-free \
327 $(useless_free_options) \
328 $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) && \
329 { echo '$(ME): found useless "if" before "free" above' 1>&2; \
330 exit 1; } || :
332 sc_cast_of_argument_to_free:
333 @prohibit='\<free *\( *\(' halt="don't cast free argument" \
334 $(_sc_search_regexp)
336 sc_cast_of_x_alloc_return_value:
337 @prohibit='\*\) *x(m|c|re)alloc\>' \
338 halt="don't cast x*alloc return value" \
339 $(_sc_search_regexp)
341 sc_cast_of_alloca_return_value:
342 @prohibit='\*\) *alloca\>' \
343 halt="don't cast alloca return value" \
344 $(_sc_search_regexp)
346 sc_space_tab:
347 @prohibit='[ ] ' \
348 halt='found SPACE-TAB sequence; remove the SPACE' \
349 $(_sc_search_regexp)
351 # Don't use *scanf or the old ato* functions in "real" code.
352 # They provide no error checking mechanism.
353 # Instead, use strto* functions.
354 sc_prohibit_atoi_atof:
355 @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\(' \
356 halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
357 $(_sc_search_regexp)
359 # Use STREQ rather than comparing strcmp == 0, or != 0.
360 sp_ = strcmp *\(.+\)
361 sc_prohibit_strcmp:
362 @prohibit='! *strcmp *\(|\<$(sp_) *[!=]=|[!=]= *$(sp_)' \
363 exclude='# *define STRN?EQ\(' \
364 halt='replace strcmp calls above with STREQ/STRNEQ' \
365 $(_sc_search_regexp)
367 # Really. You don't want to use this function.
368 # It may fail to NUL-terminate the destination,
369 # and always NUL-pads out to the specified length.
370 sc_prohibit_strncpy:
371 @prohibit='\<strncpy *\(' \
372 halt='do not use strncpy, period' \
373 $(_sc_search_regexp)
375 # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
376 # Convert all uses automatically, via these two commands:
377 # git grep -l '\<exit *(1)' \
378 # | grep -vEf .x-sc_prohibit_magic_number_exit \
379 # | xargs --no-run-if-empty \
380 # perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
381 # git grep -l '\<exit *(0)' \
382 # | grep -vEf .x-sc_prohibit_magic_number_exit \
383 # | xargs --no-run-if-empty \
384 # perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
385 sc_prohibit_magic_number_exit:
386 @prohibit='(^|[^.])\<(usage|exit|error) ?\(-?[0-9]+[,)]' \
387 exclude='exit \(77\)|error ?\(((0|77),|[^,]*)' \
388 halt='use EXIT_* values rather than magic number' \
389 $(_sc_search_regexp)
391 # Using EXIT_SUCCESS as the first argument to error is misleading,
392 # since when that parameter is 0, error does not exit. Use '0' instead.
393 sc_error_exit_success:
394 @prohibit='error *\(EXIT_SUCCESS,' \
395 in_vc_files='\.[chly]$$' \
396 halt='found error (EXIT_SUCCESS' \
397 $(_sc_search_regexp)
399 # "FATAL:" should be fully upper-cased in error messages
400 # "WARNING:" should be fully upper-cased, or fully lower-cased
401 sc_error_message_warn_fatal:
402 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
403 | grep -E '"Warning|"Fatal|"fatal' && \
404 { echo '$(ME): use FATAL, WARNING or warning' 1>&2; \
405 exit 1; } || :
407 # Error messages should not start with a capital letter
408 sc_error_message_uppercase:
409 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
410 | grep -E '"[A-Z]' \
411 | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' && \
412 { echo '$(ME): found capitalized error message' 1>&2; \
413 exit 1; } || :
415 # Error messages should not end with a period
416 sc_error_message_period:
417 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
418 | grep -E '[^."]\."' && \
419 { echo '$(ME): found error message ending in period' 1>&2; \
420 exit 1; } || :
422 sc_file_system:
423 @prohibit=file''system \
424 ignore_case=1 \
425 halt='found use of "file''system"; spell it "file system"' \
426 $(_sc_search_regexp)
428 # Don't use cpp tests of this symbol. All code assumes config.h is included.
429 sc_prohibit_have_config_h:
430 @prohibit='^# *if.*HAVE''_CONFIG_H' \
431 halt='found use of HAVE''_CONFIG_H; remove' \
432 $(_sc_search_regexp)
434 # Nearly all .c files must include <config.h>. However, we also permit this
435 # via inclusion of a package-specific header, if cfg.mk specified one.
436 # config_h_header must be suitable for grep -E.
437 config_h_header ?= <config\.h>
438 sc_require_config_h:
439 @require='^# *include $(config_h_header)' \
440 in_vc_files='\.c$$' \
441 halt='the above files do not include <config.h>' \
442 $(_sc_search_regexp)
444 # Print each file name for which the first #include does not match
445 # $(config_h_header). Like grep -m 1, this only looks at the first match.
446 perl_config_h_first_ = \
447 -e 'BEGIN {$$ret = 0}' \
448 -e 'if (/^\# *include\b/) {' \
449 -e ' if (not m{^\# *include $(config_h_header)}) {' \
450 -e ' print "$$ARGV\n";' \
451 -e ' $$ret = 1;' \
452 -e ' }' \
453 -e ' \# Move on to next file after first include' \
454 -e ' close ARGV;' \
455 -e '}' \
456 -e 'END {exit $$ret}'
458 # You must include <config.h> before including any other header file.
459 # This can possibly be via a package-specific header, if given by cfg.mk.
460 sc_require_config_h_first:
461 @if $(VC_LIST_EXCEPT) | grep '\.c$$' > /dev/null; then \
462 files=$$($(VC_LIST_EXCEPT) | grep '\.c$$') && \
463 perl -n $(perl_config_h_first_) $$files || \
464 { echo '$(ME): the above files include some other header' \
465 'before <config.h>' 1>&2; exit 1; } || :; \
466 else :; \
469 sc_prohibit_HAVE_MBRTOWC:
470 @prohibit='\bHAVE_MBRTOWC\b' \
471 halt="do not use $$prohibit; it is always defined" \
472 $(_sc_search_regexp)
474 # To use this "command" macro, you must first define two shell variables:
475 # h: the header name, with no enclosing <> or ""
476 # re: a regular expression that matches IFF something provided by $h is used.
477 define _sc_header_without_use
478 dummy=; : so we do not need a semicolon before each use; \
479 h_esc=`echo '[<"]'"$$h"'[">]'|$(SED) 's/\./\\\\./g'`; \
480 if $(VC_LIST_EXCEPT) | grep '\.c$$' > /dev/null; then \
481 files=$$(grep -l '^# *include '"$$h_esc" \
482 $$($(VC_LIST_EXCEPT) | grep '\.c$$')) && \
483 grep -LE "$$re" $$files | grep . && \
484 { echo "$(ME): the above files include $$h but don't use it" \
485 1>&2; exit 1; } || :; \
486 else :; \
488 endef
490 # Prohibit the inclusion of assert.h without an actual use of assert.
491 sc_prohibit_assert_without_use:
492 @h='assert.h' re='\<assert *\(' $(_sc_header_without_use)
494 # Prohibit the inclusion of close-stream.h without an actual use.
495 sc_prohibit_close_stream_without_use:
496 @h='close-stream.h' re='\<close_stream *\(' $(_sc_header_without_use)
498 # Prohibit the inclusion of getopt.h without an actual use.
499 sc_prohibit_getopt_without_use:
500 @h='getopt.h' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
502 # Don't include quotearg.h unless you use one of its functions.
503 sc_prohibit_quotearg_without_use:
504 @h='quotearg.h' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
506 # Don't include quote.h unless you use one of its functions.
507 sc_prohibit_quote_without_use:
508 @h='quote.h' re='\<quote((_n)? *\(|_quoting_options\>)' \
509 $(_sc_header_without_use)
511 # Don't include this header unless you use one of its functions.
512 sc_prohibit_long_options_without_use:
513 @h='long-options.h' re='\<parse_long_options *\(' \
514 $(_sc_header_without_use)
516 # Don't include this header unless you use one of its functions.
517 sc_prohibit_inttostr_without_use:
518 @h='inttostr.h' re='\<(off|[iu]max|uint)tostr *\(' \
519 $(_sc_header_without_use)
521 # Don't include this header unless you use one of its functions.
522 sc_prohibit_ignore_value_without_use:
523 @h='ignore-value.h' re='\<ignore_(value|ptr) *\(' \
524 $(_sc_header_without_use)
526 # Don't include this header unless you use one of its functions.
527 sc_prohibit_error_without_use:
528 @h='error.h' \
529 re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
530 $(_sc_header_without_use)
532 # Don't include xalloc.h unless you use one of its functions.
533 # Consider these symbols:
534 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
535 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
536 # Divide into two sets on case, and filter each through this:
537 # | sort | perl -MRegexp::Assemble -le \
538 # 'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
539 # Note this was produced by the above:
540 # _xa1 = \
541 #x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
542 # But we can do better, in at least two ways:
543 # 1) take advantage of two "dup"-suffixed strings:
544 # x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
545 # 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
546 # "char|[cmz]"
547 # x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
548 _xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
549 _xa2 = X([CZ]|N?M)ALLOC
550 sc_prohibit_xalloc_without_use:
551 @h='xalloc.h' \
552 re='\<($(_xa1)|$(_xa2)) *\('\
553 $(_sc_header_without_use)
555 # Extract function names:
556 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
557 _hash_re = \
558 clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
559 _hash_fn = \<($(_hash_re)) *\(
560 _hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
561 sc_prohibit_hash_without_use:
562 @h='hash.h' \
563 re='$(_hash_fn)|$(_hash_struct)'\
564 $(_sc_header_without_use)
566 sc_prohibit_cloexec_without_use:
567 @h='cloexec.h' re='\<(set_cloexec_flag|dup_cloexec) *\(' \
568 $(_sc_header_without_use)
570 sc_prohibit_posixver_without_use:
571 @h='posixver.h' re='\<posix2_version *\(' $(_sc_header_without_use)
573 sc_prohibit_same_without_use:
574 @h='same.h' re='\<same_name *\(' $(_sc_header_without_use)
576 sc_prohibit_hash_pjw_without_use:
577 @h='hash-pjw.h' \
578 re='\<hash_pjw\>' \
579 $(_sc_header_without_use)
581 sc_prohibit_safe_read_without_use:
582 @h='safe-read.h' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
583 $(_sc_header_without_use)
585 sc_prohibit_argmatch_without_use:
586 @h='argmatch.h' \
587 re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<(invalid_arg|argmatch(_exit_fn|_(in)?valid)?) *\()' \
588 $(_sc_header_without_use)
590 sc_prohibit_canonicalize_without_use:
591 @h='canonicalize.h' \
592 re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode|file_name)' \
593 $(_sc_header_without_use)
595 sc_prohibit_root_dev_ino_without_use:
596 @h='root-dev-ino.h' \
597 re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
598 $(_sc_header_without_use)
600 sc_prohibit_openat_without_use:
601 @h='openat.h' \
602 re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat|(FCHMOD|FCHOWN|STAT)AT_INLINE)\>' \
603 $(_sc_header_without_use)
605 # Prohibit the inclusion of c-ctype.h without an actual use.
606 ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
607 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
608 sc_prohibit_c_ctype_without_use:
609 @h='c-ctype.h' re='\<c_($(ctype_re)) *\(' \
610 $(_sc_header_without_use)
612 # The following list was generated by running:
613 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
614 # | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
615 _sig_functions = \
616 bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
617 sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
618 siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
619 sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
620 _sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
621 # The following were extracted from "man signal.h" manually.
622 _sig_types_and_consts = \
623 MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
624 SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
625 SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
626 SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
627 sigstack sigval stack_t ucontext_t
628 # generated via this:
629 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
630 _sig_names = \
631 SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
632 SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
633 SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
634 SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
635 SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
636 SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
637 SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
638 SIGXCPU SIGXFSZ
639 _sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
641 # Prohibit the inclusion of signal.h without an actual use.
642 sc_prohibit_signal_without_use:
643 @h='signal.h' \
644 re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
645 $(_sc_header_without_use)
647 # Don't include stdio--.h unless you use one of its functions.
648 sc_prohibit_stdio--_without_use:
649 @h='stdio--.h' re='\<((f(re)?|p)open|tmpfile) *\(' \
650 $(_sc_header_without_use)
652 # Don't include stdio-safer.h unless you use one of its functions.
653 sc_prohibit_stdio-safer_without_use:
654 @h='stdio-safer.h' re='\<((f(re)?|p)open|tmpfile)_safer *\(' \
655 $(_sc_header_without_use)
657 # Prohibit the inclusion of strings.h without a sensible use.
658 # Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
659 sc_prohibit_strings_without_use:
660 @h='strings.h' \
661 re='\<(strn?casecmp|ffs(ll)?)\>' \
662 $(_sc_header_without_use)
664 # Extract the raw list of symbol names with this:
665 gl_extract_define_simple = \
666 /^\# *define ([A-Z]\w+)\(/ and print $$1
667 # Filter out duplicates and convert to a space-separated list:
668 _intprops_names = \
669 $(shell f=$(gnulib_dir)/lib/intprops.h; \
670 perl -lne '$(gl_extract_define_simple)' $$f | sort -u | tr '\n' ' ')
671 # Remove trailing space and convert to a regular expression:
672 _intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
673 # Prohibit the inclusion of intprops.h without an actual use.
674 sc_prohibit_intprops_without_use:
675 @h='intprops.h' \
676 re='\<($(_intprops_syms_re)) *\(' \
677 $(_sc_header_without_use)
679 _stddef_syms_re = NULL|offsetof|ptrdiff_t|size_t|wchar_t
680 # Prohibit the inclusion of stddef.h without an actual use.
681 sc_prohibit_stddef_without_use:
682 @h='stddef.h' \
683 re='\<($(_stddef_syms_re))\>' \
684 $(_sc_header_without_use)
686 _de1 = dirfd|(close|(fd)?open|read|rewind|seek|tell)dir(64)?(_r)?
687 _de2 = (versionsort|struct dirent|getdirentries|alphasort|scandir(at)?)(64)?
688 _de3 = MAXNAMLEN|DIR|ino_t|d_ino|d_fileno|d_namlen
689 _dirent_syms_re = $(_de1)|$(_de2)|$(_de3)
690 # Prohibit the inclusion of dirent.h without an actual use.
691 sc_prohibit_dirent_without_use:
692 @h='dirent.h' \
693 re='\<($(_dirent_syms_re))\>' \
694 $(_sc_header_without_use)
696 # Prohibit the inclusion of verify.h without an actual use.
697 sc_prohibit_verify_without_use:
698 @h='verify.h' \
699 re='\<(verify(true|expr)?|assume|static_assert) *\(' \
700 $(_sc_header_without_use)
702 # Don't include xfreopen.h unless you use one of its functions.
703 sc_prohibit_xfreopen_without_use:
704 @h='xfreopen.h' re='\<xfreopen *\(' $(_sc_header_without_use)
706 sc_obsolete_symbols:
707 @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
708 halt='do not use HAVE''_FCNTL_H or O'_NDELAY \
709 $(_sc_search_regexp)
711 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
713 # Each nonempty ChangeLog line must start with a year number, or a TAB.
714 sc_changelog:
715 @prohibit='^[^12 ]' \
716 in_vc_files='^ChangeLog$$' \
717 halt='found unexpected prefix in a ChangeLog' \
718 $(_sc_search_regexp)
720 # Ensure that each .c file containing a "main" function also
721 # calls bindtextdomain.
722 sc_bindtextdomain:
723 @require='bindtextdomain *\(' \
724 in_vc_files='\.c$$' \
725 containing='\<main *(' \
726 halt='the above files do not call bindtextdomain' \
727 $(_sc_search_regexp)
729 # Require that the final line of each test-lib.sh-using test be this one:
730 # Exit $fail
731 # Note: this test requires GNU grep's --label= option.
732 Exit_witness_file ?= tests/test-lib.sh
733 Exit_base := $(notdir $(Exit_witness_file))
734 sc_require_test_exit_idiom:
735 @if test -f $(srcdir)/$(Exit_witness_file); then \
736 die=0; \
737 for i in $$(grep -l -F 'srcdir/$(Exit_base)' \
738 $$($(VC_LIST) tests)); do \
739 tail -n1 $$i | grep '^Exit .' > /dev/null \
740 && : || { die=1; echo $$i; } \
741 done; \
742 test $$die = 1 && \
743 { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
744 echo 1>&2 'Exit something'; \
745 exit 1; } || :; \
748 sc_trailing_blank:
749 @prohibit='[ ]$$' \
750 halt='found trailing blank(s)' \
751 exclude='^Binary file .* matches$$' \
752 $(_sc_search_regexp)
754 # Match lines like the following, but where there is only one space
755 # between the options and the description:
756 # -D, --all-repeated[=delimit-method] print all duplicate lines\n
757 longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
758 sc_two_space_separator_in_usage:
759 @prohibit='^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
760 halt='help2man requires at least two spaces between an option and its description'\
761 $(_sc_search_regexp)
763 # A regexp matching function names like "error" that may be used
764 # to emit translatable messages.
765 _gl_translatable_diag_func_re ?= error
767 # Look for diagnostics that aren't marked for translation.
768 # This won't find any for which error's format string is on a separate line.
769 sc_unmarked_diagnostics:
770 @prohibit='\<$(_gl_translatable_diag_func_re) *\([^"]*"[^"]*[a-z]{3}' \
771 exclude='(_|ngettext ?)\(' \
772 halt='found unmarked diagnostic(s)' \
773 $(_sc_search_regexp)
775 # Avoid useless parentheses like those in this example:
776 # #if defined (SYMBOL) || defined (SYM2)
777 sc_useless_cpp_parens:
778 @prohibit='^# *if .*defined *\(' \
779 halt='found useless parentheses in cpp directive' \
780 $(_sc_search_regexp)
782 # List headers for which HAVE_HEADER_H is always true, assuming you are
783 # using the appropriate gnulib module. CAUTION: for each "unnecessary"
784 # #if HAVE_HEADER_H that you remove, be sure that your project explicitly
785 # requires the gnulib module that guarantees the usability of that header.
786 gl_assured_headers_ = \
787 cd $(gnulib_dir)/lib && echo *.in.h|$(SED) 's/\.in\.h//g'
789 # Convert the list of names to upper case, and replace each space with "|".
790 az_ = abcdefghijklmnopqrstuvwxyz
791 AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
792 gl_header_upper_case_or_ = \
793 $$($(gl_assured_headers_) \
794 | tr $(az_)/.- $(AZ_)___ \
795 | tr -s ' ' '|' \
797 sc_prohibit_always_true_header_tests:
798 @or=$(gl_header_upper_case_or_); \
799 re="HAVE_($$or)_H"; \
800 prohibit='\<'"$$re"'\>' \
801 halt=$$(printf '%s\n' \
802 'do not test the above HAVE_<header>_H symbol(s);' \
803 ' with the corresponding gnulib module, they are always true') \
804 $(_sc_search_regexp)
806 sc_prohibit_defined_have_decl_tests:
807 @prohibit='(#[ ]*ifn?def|\<defined)\>[ (]+HAVE_DECL_' \
808 halt='HAVE_DECL macros are always defined' \
809 $(_sc_search_regexp)
811 # ==================================================================
812 gl_other_headers_ ?= \
813 intprops.h \
814 openat.h \
815 stat-macros.h
817 # Perl -lne code to extract "significant" cpp-defined symbols from a
818 # gnulib header file, eliminating a few common false-positives.
819 # The exempted names below are defined only conditionally in gnulib,
820 # and hence sometimes must/may be defined in application code.
821 gl_extract_significant_defines_ = \
822 /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
823 && $$2 !~ /(?:rpl_|_used_without_)/\
824 && $$1 !~ /^(?:NSIG|ENODATA)$$/\
825 && $$1 !~ /^(?:SA_RESETHAND|SA_RESTART)$$/\
826 and print $$1
828 # Create a list of regular expressions matching the names
829 # of macros that are guaranteed to be defined by parts of gnulib.
830 define def_sym_regex
831 gen_h=$(gl_generated_headers_); \
832 (cd $(gnulib_dir)/lib; \
833 for f in *.in.h $(gl_other_headers_); do \
834 test -f $$f \
835 && perl -lne '$(gl_extract_significant_defines_)' $$f; \
836 done; \
837 ) | sort -u \
838 | $(SED) 's/^/^ *# *(define|undef) */;s/$$/\\>/'
839 endef
841 # Don't define macros that we already get from gnulib header files.
842 sc_prohibit_always-defined_macros:
843 @if test -d $(gnulib_dir); then \
844 case $$(echo all: | grep -l -f - Makefile) in Makefile);; *) \
845 echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
846 esac; \
847 $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT)) \
848 && { echo '$(ME): define the above via some gnulib .h file' \
849 1>&2; exit 1; } || :; \
851 # ==================================================================
853 # Prohibit checked in backup files.
854 sc_prohibit_backup_files:
855 @$(VC_LIST) | grep '~$$' && \
856 { echo '$(ME): found version controlled backup file' 1>&2; \
857 exit 1; } || :
859 # Require the latest GPL.
860 sc_GPL_version:
861 @prohibit='either ''version [^3]' \
862 halt='GPL vN, N!=3' \
863 $(_sc_search_regexp)
865 # Require the latest GFDL. Two regexp, since some .texi files end up
866 # line wrapping between 'Free Documentation License,' and 'Version'.
867 _GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
868 sc_GFDL_version:
869 @prohibit='$(_GFDL_regexp)' \
870 halt='GFDL vN, N!=3' \
871 $(_sc_search_regexp)
873 # Don't use Texinfo's @acronym{}.
874 # https://lists.gnu.org/archive/html/bug-gnulib/2010-03/msg00321.html
875 texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
876 sc_texinfo_acronym:
877 @prohibit='@acronym\{' \
878 in_vc_files='$(texinfo_suffix_re_)' \
879 halt='found use of Texinfo @acronym{}' \
880 $(_sc_search_regexp)
882 cvs_keywords = \
883 Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
885 sc_prohibit_cvs_keyword:
886 @prohibit='\$$($(cvs_keywords))\$$' \
887 halt='do not use CVS keyword expansion' \
888 $(_sc_search_regexp)
890 # This Perl code is slightly obfuscated. Not only is each "$" doubled
891 # because it's in a Makefile, but the $$c's are comments; we cannot
892 # use "#" due to the way the script ends up concatenated onto one line.
893 # It would be much more concise, and would produce better output (including
894 # counts) if written as:
895 # perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
896 # but that would be far less efficient, reading the entire contents
897 # of each file, rather than just the last two bytes of each.
898 # In addition, while the code below detects both blank lines and a missing
899 # newline at EOF, the above detects only the former.
901 # This is a perl script that is expected to be the single-quoted argument
902 # to a command-line "-le". The remaining arguments are file names.
903 # Print the name of each file that does not end in exactly one newline byte.
904 # I.e., warn if there are blank lines (2 or more newlines), or if the
905 # last byte is not a newline. However, currently we don't complain
906 # about any file that contains exactly one byte.
907 # Exit nonzero if at least one such file is found, otherwise, exit 0.
908 # Warn about, but otherwise ignore open failure. Ignore seek/read failure.
910 # Use this if you want to remove trailing empty lines from selected files:
911 # perl -pi -0777 -e 's/\n\n+$/\n/' files...
913 require_exactly_one_NL_at_EOF_ = \
914 foreach my $$f (@ARGV) \
916 open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next; \
917 my $$p = sysseek (F, -2, 2); \
918 my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
919 my $$last_two_bytes; \
920 defined $$p and $$p = sysread F, $$last_two_bytes, 2; \
921 close F; \
922 $$c = "ignore read failure"; \
923 $$p && ($$last_two_bytes eq "\n\n" \
924 || substr ($$last_two_bytes,1) ne "\n") \
925 and (print $$f), $$fail=1; \
927 END { exit defined $$fail }
928 sc_prohibit_empty_lines_at_EOF:
929 @perl -le '$(require_exactly_one_NL_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
930 || { echo '$(ME): empty line(s) or no newline at EOF' \
931 1>&2; exit 1; } || :
933 # Make sure we don't use st_blocks. Use ST_NBLOCKS instead.
934 # This is a bit of a kludge, since it prevents use of the string
935 # even in comments, but for now it does the job with no false positives.
936 sc_prohibit_stat_st_blocks:
937 @prohibit='[.>]st_blocks' \
938 halt='do not use st_blocks; use ST_NBLOCKS' \
939 $(_sc_search_regexp)
941 # Make sure we don't define any S_IS* macros in src/*.c files.
942 # They're already defined via gnulib's sys/stat.h replacement.
943 sc_prohibit_S_IS_definition:
944 @prohibit='^ *# *define *S_IS' \
945 halt='do not define S_IS* macros; include <sys/stat.h>' \
946 $(_sc_search_regexp)
948 # Perl block to convert a match to FILE_NAME:LINENO:TEST,
949 # that is shared by two definitions below.
950 perl_filename_lineno_text_ = \
951 -e ' {' \
952 -e ' $$n = ($$` =~ tr/\n/\n/ + 1);' \
953 -e ' ($$v = $$&) =~ s/\n/\\n/g;' \
954 -e ' print "$$ARGV:$$n:$$v\n";' \
955 -e ' }'
957 prohibit_doubled_words_ = \
958 the then in an on if is it but for or at and do to
959 # expand the regex before running the check to avoid using expensive captures
960 prohibit_doubled_word_expanded_ = \
961 $(join $(prohibit_doubled_words_),$(addprefix \s+,$(prohibit_doubled_words_)))
962 prohibit_doubled_word_RE_ ?= \
963 /\b(?:$(subst $(_sp),|,$(prohibit_doubled_word_expanded_)))\b/gims
964 prohibit_doubled_word_ = \
965 -e 'while ($(prohibit_doubled_word_RE_))' \
966 $(perl_filename_lineno_text_)
968 # Define this to a regular expression that matches
969 # any filename:dd:match lines you want to ignore.
970 # The default is to ignore no matches.
971 ignore_doubled_word_match_RE_ ?= ^$$
973 sc_prohibit_doubled_word:
974 @perl -n -0777 $(prohibit_doubled_word_) $$($(VC_LIST_EXCEPT)) \
975 | grep -vE '$(ignore_doubled_word_match_RE_)' \
976 | grep . && { echo '$(ME): doubled words' 1>&2; exit 1; } || :
978 # A regular expression matching undesirable combinations of words like
979 # "can not"; this matches them even when the two words appear on different
980 # lines, but not when there is an intervening delimiter like "#" or "*".
981 # Similarly undesirable, "See @xref{...}", since an @xref should start
982 # a sentence. Explicitly prohibit any prefix of "see" or "also".
983 # Also prohibit a prefix matching "\w+ +".
984 # @pxref gets the same see/also treatment and should be parenthesized;
985 # presume it must *not* start a sentence.
986 # POSIX spells it "timestamp" rather than "time\s+stamp", so we do, too.
987 bad_xref_re_ ?= (?:[\w,:;] +|(?:see|also)\s+)\@xref\{
988 bad_pxref_re_ ?= (?:[.!?]|(?:see|also))\s+\@pxref\{
989 prohibit_undesirable_word_seq_RE_ ?= \
990 /(?:\bcan\s+not\b|\btime\s+stamps?\b|$(bad_xref_re_)|$(bad_pxref_re_))/gims
991 prohibit_undesirable_word_seq_ = \
992 -e 'while ($(prohibit_undesirable_word_seq_RE_))' \
993 $(perl_filename_lineno_text_)
994 # Define this to a regular expression that matches
995 # any filename:dd:match lines you want to ignore.
996 # The default is to ignore no matches.
997 ignore_undesirable_word_sequence_RE_ ?= ^$$
999 sc_prohibit_undesirable_word_seq:
1000 @perl -n -0777 $(prohibit_undesirable_word_seq_) \
1001 $$($(VC_LIST_EXCEPT)) \
1002 | grep -vE '$(ignore_undesirable_word_sequence_RE_)' | grep . \
1003 && { echo '$(ME): undesirable word sequence' >&2; exit 1; } || :
1005 # Except for shell files and for loops, double semicolon is probably a mistake
1006 sc_prohibit_double_semicolon:
1007 @prohibit='; *;[ {} \]*(/[/*]|$$)' \
1008 in_vc_files='\.[chly]$$' \
1009 exclude='\bfor *\(.*\)' \
1010 halt="Double semicolon detected" \
1011 $(_sc_search_regexp)
1013 _ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
1014 _ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
1015 # Using test's -a and -o operators is not portable.
1016 # We prefer test over [, since the latter is spelled [[ in configure.ac.
1017 sc_prohibit_test_minus_ao:
1018 @prohibit='(\<test| \[+) .+ -[ao] ' \
1019 halt='$(_ptm1); $(_ptm2)' \
1020 $(_sc_search_regexp)
1022 # Avoid a test bashism.
1023 sc_prohibit_test_double_equal:
1024 @prohibit='(\<test| \[+) .+ == ' \
1025 containing='#! */bin/[a-z]*sh' \
1026 halt='use "test x = x", not "test x =''= x"' \
1027 $(_sc_search_regexp)
1029 # Each program that uses proper_name_utf8 must link with one of the
1030 # ICONV libraries. Otherwise, some ICONV library must appear in LDADD.
1031 # The perl -0777 invocation below extracts the possibly-multi-line
1032 # definition of LDADD from the appropriate Makefile.am and exits 0
1033 # when it contains "ICONV".
1034 sc_proper_name_utf8_requires_ICONV:
1035 @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
1036 if test "x$$progs" != x; then \
1037 fail=0; \
1038 for p in $$progs; do \
1039 dir=$$(dirname "$$p"); \
1040 perl -0777 \
1041 -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)' \
1042 $$dir/Makefile.am && continue; \
1043 base=$$(basename "$$p" .c); \
1044 grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
1045 || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
1046 done; \
1047 test $$fail = 1 && \
1048 { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
1049 exit 1; } || :; \
1052 # Warn about "c0nst struct Foo const foo[]",
1053 # but not about "char const *const foo" or "#define const const".
1054 sc_redundant_const:
1055 @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
1056 halt='redundant "const" in declarations' \
1057 $(_sc_search_regexp)
1059 sc_const_long_option:
1060 @prohibit='^ *static.*struct option ' \
1061 exclude='const struct option|struct option const' \
1062 halt='add "const" to the above declarations' \
1063 $(_sc_search_regexp)
1065 NEWS_hash = \
1066 $$($(SED) -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
1067 $(srcdir)/NEWS \
1068 | perl -0777 -pe \
1069 's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms' \
1070 | md5sum - \
1071 | $(SED) 's/ .*//')
1073 # Ensure that we don't accidentally insert an entry into an old NEWS block.
1074 sc_immutable_NEWS:
1075 @if test -f $(srcdir)/NEWS; then \
1076 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
1077 { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
1080 # Update the hash stored above. Do this after each release and
1081 # for any corrections to old entries.
1082 update-NEWS-hash: NEWS
1083 perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
1084 $(srcdir)/cfg.mk
1086 # Ensure that we use only the standard $(VAR) notation,
1087 # not @...@ in Makefile.am, now that we can rely on automake
1088 # to emit a definition for each substituted variable.
1089 # However, there is still one case in which @VAR@ use is not just
1090 # legitimate, but actually required: when augmenting an automake-defined
1091 # variable with a prefix. For example, gettext uses this:
1092 # MAKEINFO = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE= @MAKEINFO@
1093 # otherwise, makeinfo would put German or French (current locale)
1094 # navigation hints in the otherwise-English documentation.
1096 # Allow the package to add exceptions via a hook in cfg.mk;
1097 # for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
1098 # setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
1099 _makefile_at_at_check_exceptions ?=
1100 sc_makefile_at_at_check:
1101 @perl -ne '/\@\w+\@/' \
1102 -e ' && !/(\w+)\s+=.*\@\1\@$$/' \
1103 -e ''$(_makefile_at_at_check_exceptions) \
1104 -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
1105 $$($(VC_LIST_EXCEPT) | grep -E '(^|/)(Makefile\.am|[^/]+\.mk)$$') \
1106 && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
1108 news-check: NEWS
1109 $(AM_V_GEN)if $(SED) -n $(news-check-lines-spec)p $< \
1110 | grep -E $(news-check-regexp) >/dev/null; then \
1111 :; \
1112 else \
1113 echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2; \
1114 exit 1; \
1117 sc_makefile_TAB_only_indentation:
1118 @prohibit='^ [ ]{8}' \
1119 in_vc_files='akefile|\.mk$$' \
1120 halt='found TAB-8-space indentation' \
1121 $(_sc_search_regexp)
1123 sc_m4_quote_check:
1124 @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
1125 in_vc_files='(^configure\.ac|\.m4)$$' \
1126 halt='quote the first arg to AC_DEF*' \
1127 $(_sc_search_regexp)
1129 fix_po_file_diag = \
1130 'you have changed the set of files with translatable diagnostics;\n\
1131 apply the above patch\n'
1133 # Generate a list of files in which to search for translatable strings.
1134 perl_translatable_files_list_ = \
1135 -e 'foreach $$file (@ARGV) {' \
1136 -e ' \# Consider only file extensions with one or two letters' \
1137 -e ' $$file =~ /\...?$$/ or next;' \
1138 -e ' \# Ignore m4 and mk files' \
1139 -e ' $$file =~ /\.m[4k]$$/ and next;' \
1140 -e ' \# Ignore a .c or .h file with a corresponding .l or .y file' \
1141 -e ' $$file =~ /(.+)\.[ch]$$/ && (-e "$${1}.l" || -e "$${1}.y")' \
1142 -e ' and next;' \
1143 -e ' \# Skip unreadable files' \
1144 -e ' -r $$file or next;' \
1145 -e ' print "$$file ";' \
1146 -e '}'
1148 # Verify that all source files using _() (more specifically, files that
1149 # match $(_gl_translatable_string_re)) are listed in po/POTFILES.in.
1150 po_file ?= $(srcdir)/po/POTFILES.in
1151 generated_files ?= $(srcdir)/lib/*.[ch]
1152 _gl_translatable_string_re ?= \b(N?_|gettext *)\([^)"]*("|$$)
1153 sc_po_check:
1154 @if test -f $(po_file); then \
1155 grep -E -v '^(#|$$)' $(po_file) \
1156 | grep -v '^src/false\.c$$' | sort > $@-1; \
1157 files=$$(perl $(perl_translatable_files_list_) \
1158 $$($(VC_LIST_EXCEPT)) $(generated_files)); \
1159 grep -E -l '$(_gl_translatable_string_re)' $$files \
1160 | $(SED) 's|^$(_dot_escaped_srcdir)/||' | sort -u > $@-2; \
1161 diff -u -L $(po_file) -L $(po_file) $@-1 $@-2 \
1162 || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; }; \
1163 rm -f $@-1 $@-2; \
1166 # Sometimes it is useful to change the PATH environment variable
1167 # in Makefiles. When doing so, it's better not to use the Unix-centric
1168 # path separator of ':', but rather the automake-provided '$(PATH_SEPARATOR)'.
1169 msg = 'Do not use ":" above; use $$(PATH_SEPARATOR) instead'
1170 sc_makefile_path_separator_check:
1171 @prohibit='PATH[=].*:' \
1172 in_vc_files='akefile|\.mk$$' \
1173 halt=$(msg) \
1174 $(_sc_search_regexp)
1176 # Check that 'make alpha' will not fail at the end of the process,
1177 # i.e., when pkg-M.N.tar.xz already exists (either in "." or in ../release)
1178 # and is read-only.
1179 writable-files:
1180 $(AM_V_GEN)if test -d $(release_archive_dir); then \
1181 for file in $(DIST_ARCHIVES); do \
1182 for p in ./ $(release_archive_dir)/; do \
1183 test -e $$p$$file || continue; \
1184 test -w $$p$$file \
1185 || { echo ERROR: $$p$$file is not writable; fail=1; }; \
1186 done; \
1187 done; \
1188 test "$$fail" && exit 1 || : ; \
1189 else :; \
1192 v_etc_file = $(gnulib_dir)/lib/version-etc.c
1193 sample-test = tests/sample-test
1194 texi = doc/$(PACKAGE).texi
1195 # Make sure that the copyright date in $(v_etc_file) is up to date.
1196 # Do the same for the $(sample-test) and the main doc/.texi file.
1197 sc_copyright_check:
1198 @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' \
1199 in_files=$(v_etc_file) \
1200 halt='out of date copyright in $(v_etc_file); update it' \
1201 $(_sc_search_regexp)
1202 @require='# Copyright \(C\) '$$(date +%Y)' Free' \
1203 in_vc_files=$(sample-test) \
1204 halt='out of date copyright in $(sample-test); update it' \
1205 $(_sc_search_regexp)
1206 @require='Copyright @copyright\{\} .*'$$(date +%Y) \
1207 in_vc_files=$(texi) \
1208 halt='out of date copyright in $(texi); update it' \
1209 $(_sc_search_regexp)
1211 # If tests/help-version exists and seems to be new enough, assume that its
1212 # use of init.sh and path_prepend_ is correct, and ensure that every other
1213 # use of init.sh is identical.
1214 # This is useful because help-version cross-checks prog --version
1215 # with $(VERSION), which verifies that its path_prepend_ invocation
1216 # sets PATH correctly. This is an inexpensive way to ensure that
1217 # the other init.sh-using tests also get it right.
1218 _hv_file ?= $(srcdir)/tests/help-version
1219 _hv_regex_weak ?= ^ *\. .*/init\.sh"
1220 # Fix syntax-highlighters "
1221 _hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
1222 sc_cross_check_PATH_usage_in_tests:
1223 @if test -f $(_hv_file); then \
1224 grep -l 'VERSION mismatch' $(_hv_file) >/dev/null \
1225 || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2; \
1226 exit 0; }; \
1227 grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null \
1228 || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1229 exit 1; }; \
1230 good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file)); \
1231 grep -LFx "$$good" \
1232 $$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT))) \
1233 | grep . && \
1234 { echo "$(ME): the above files use path_prepend_ inconsistently" \
1235 1>&2; exit 1; } || :; \
1238 # BRE regex of file contents to identify a test script.
1239 _test_script_regex ?= \<init\.sh\>
1241 # In tests, use "compare expected actual", not the reverse.
1242 sc_prohibit_reversed_compare_failure:
1243 @prohibit='\<compare [^ ]+ ([^ ]*exp|/dev/null)' \
1244 containing='$(_test_script_regex)' \
1245 halt='reversed compare arguments' \
1246 $(_sc_search_regexp)
1248 # #if HAVE_... will evaluate to false for any non numeric string.
1249 # That would be flagged by using -Wundef, however gnulib currently
1250 # tests many undefined macros, and so we can't enable that option.
1251 # So at least preclude common boolean strings as macro values.
1252 sc_Wundef_boolean:
1253 @prohibit='^#define.*(yes|no|true|false)$$' \
1254 in_files='$(CONFIG_INCLUDE)' \
1255 halt='Use 0 or 1 for macro values' \
1256 $(_sc_search_regexp)
1258 # Even if you use pathmax.h to guarantee that PATH_MAX is defined, it might
1259 # not be constant, or might overflow a stack. In general, use PATH_MAX as
1260 # a limit, not an array or alloca size.
1261 sc_prohibit_path_max_allocation:
1262 @prohibit='(\balloca *\([^)]*|\[[^]]*)\bPATH_MAX' \
1263 halt='Avoid stack allocations of size PATH_MAX' \
1264 $(_sc_search_regexp)
1266 sc_vulnerable_makefile_CVE-2009-4029:
1267 @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1268 in_files='(^|/)Makefile\.in$$' \
1269 halt=$$(printf '%s\n' \
1270 'the above files are vulnerable; beware of running' \
1271 ' "make dist*" rules, and upgrade to fixed automake' \
1272 ' see https://bugzilla.redhat.com/show_bug.cgi?id=542609 for details') \
1273 $(_sc_search_regexp)
1275 sc_vulnerable_makefile_CVE-2012-3386:
1276 @prohibit='chmod a\+w \$$\(distdir\)' \
1277 in_files='(^|/)Makefile\.in$$' \
1278 halt=$$(printf '%s\n' \
1279 'the above files are vulnerable; beware of running' \
1280 ' "make distcheck", and upgrade to fixed automake' \
1281 ' see https://bugzilla.redhat.com/show_bug.cgi?id=CVE-2012-3386 for details') \
1282 $(_sc_search_regexp)
1284 vc-diff-check:
1285 $(AM_V_GEN)(unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1286 $(AM_V_at)if test -s vc-diffs; then \
1287 cat vc-diffs; \
1288 echo "Some files are locally modified:" 1>&2; \
1289 exit 1; \
1290 else \
1291 rm vc-diffs; \
1294 rel-files = $(DIST_ARCHIVES)
1296 gnulib-version = $$(cd $(gnulib_dir) \
1297 && { git describe || git rev-parse --short=10 HEAD; } )
1298 bootstrap-tools ?= autoconf,automake,gnulib
1300 gpgv = $$(gpgv2 --version >/dev/null && echo gpgv2 || echo gpgv)
1301 # If it's not already specified, derive the GPG key ID from
1302 # the signed tag we've just applied to mark this release.
1303 gpg_key_ID ?= \
1304 $$(cd $(srcdir) \
1305 && git cat-file tag v$(VERSION) \
1306 | $(gpgv) --status-fd 1 --keyring /dev/null - - 2>/dev/null \
1307 | awk '/^\[GNUPG:\] ERRSIG / {print $$3; exit}')
1309 translation_project_ ?= coordinator@translationproject.org
1311 # Make info-gnu the default only for a stable release.
1312 announcement_Cc_stable = $(translation_project_), $(PACKAGE_BUGREPORT)
1313 announcement_mail_headers_stable = \
1314 To: info-gnu@gnu.org \
1315 Cc: $(announcement_Cc_) \
1316 Mail-Followup-To: $(PACKAGE_BUGREPORT)
1318 announcement_Cc_alpha = $(translation_project_)
1319 announcement_mail_headers_alpha = \
1320 To: $(PACKAGE_BUGREPORT) \
1321 Cc: $(announcement_Cc_)
1323 announcement_mail_Cc_beta = $(announcement_mail_Cc_alpha)
1324 announcement_mail_headers_beta = $(announcement_mail_headers_alpha)
1326 announcement_mail_Cc_ ?= $(announcement_mail_Cc_$(release-type))
1327 announcement_mail_headers_ ?= $(announcement_mail_headers_$(release-type))
1328 announcement: NEWS ChangeLog $(rel-files)
1329 # Not $(AM_V_GEN) since the output of this command serves as
1330 # announcement message: it would start with " GEN announcement".
1331 $(AM_V_at)$(srcdir)/$(_build-aux)/announce-gen \
1332 --mail-headers='$(announcement_mail_headers_)' \
1333 --release-type=$(release-type) \
1334 --package=$(PACKAGE) \
1335 --prev=$(PREV_VERSION) \
1336 --curr=$(VERSION) \
1337 --gpg-key-id=$(gpg_key_ID) \
1338 --srcdir=$(srcdir) \
1339 --news=$(srcdir)/NEWS \
1340 --bootstrap-tools=$(bootstrap-tools) \
1341 $$(case ,$(bootstrap-tools), in (*,gnulib,*) \
1342 echo --gnulib-version=$(gnulib-version);; esac) \
1343 --no-print-checksums \
1344 $(addprefix --url-dir=, $(url_dir_list))
1346 .PHONY: release-commit
1347 release-commit:
1348 $(AM_V_GEN)cd $(srcdir) \
1349 && $(_build-aux)/do-release-commit-and-tag \
1350 -C $(abs_builddir) $(RELEASE)
1352 ## ---------------- ##
1353 ## Updating files. ##
1354 ## ---------------- ##
1356 ftp-gnu = https://ftp.gnu.org/gnu
1357 www-gnu = https://www.gnu.org
1359 upload_dest_dir_ ?= $(PACKAGE)
1360 upload_command = \
1361 $(srcdir)/$(_build-aux)/gnupload $(GNUPLOADFLAGS) \
1362 --to $(gnu_rel_host):$(upload_dest_dir_) \
1363 $(rel-files)
1364 emit_upload_commands:
1365 @echo =====================================
1366 @echo =====================================
1367 @echo '$(upload_command)'
1368 @echo '# send the ~/announce-$(my_distdir) e-mail'
1369 @echo =====================================
1370 @echo =====================================
1372 .PHONY: upload
1373 upload:
1374 $(AM_V_GEN)$(upload_command)
1376 define emit-commit-log
1377 printf '%s\n' 'maint: post-release administrivia' '' \
1378 '* NEWS: Add header line for next release.' \
1379 '* .prev-version: Record previous version.' \
1380 '* cfg.mk (old_NEWS_hash): Auto-update.'
1381 endef
1383 .PHONY: no-submodule-changes
1384 no-submodule-changes:
1385 $(AM_V_GEN)if test -d $(srcdir)/.git \
1386 && git --version >/dev/null 2>&1; then \
1387 diff=$$(cd $(srcdir) && git submodule -q foreach \
1388 git diff-index --name-only HEAD) \
1389 || exit 1; \
1390 case $$diff in '') ;; \
1391 *) echo '$(ME): submodule files are locally modified:'; \
1392 echo "$$diff"; exit 1;; esac; \
1393 else \
1394 : ; \
1397 submodule-checks ?= no-submodule-changes public-submodule-commit
1399 # Ensure that each sub-module commit we're using is public.
1400 # Without this, it is too easy to tag and release code that
1401 # cannot be built from a fresh clone.
1402 .PHONY: public-submodule-commit
1403 public-submodule-commit:
1404 $(AM_V_GEN)if test -d $(srcdir)/.git \
1405 && git --version >/dev/null 2>&1; then \
1406 cd $(srcdir) && \
1407 git submodule --quiet foreach \
1408 'test "$$(git rev-parse "$$sha1")" \
1409 = "$$(git merge-base origin "$$sha1")"' \
1410 || { echo '$(ME): found non-public submodule commit' >&2; \
1411 exit 1; }; \
1412 else \
1413 : ; \
1415 # This rule has a high enough utility/cost ratio that it should be a
1416 # dependent of "check" by default. However, some of us do occasionally
1417 # commit a temporary change that deliberately points to a non-public
1418 # submodule commit, and want to be able to use rules like "make check".
1419 # In that case, run e.g., "make check gl_public_submodule_commit="
1420 # to disable this test.
1421 gl_public_submodule_commit ?= public-submodule-commit
1422 check: $(gl_public_submodule_commit)
1424 .PHONY: alpha beta stable release
1425 ALL_RECURSIVE_TARGETS += alpha beta stable
1426 alpha beta stable: $(local-check) writable-files $(submodule-checks)
1427 $(AM_V_GEN)test $@ = stable \
1428 && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
1429 || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1430 || :
1431 $(AM_V_at)$(MAKE) vc-diff-check
1432 $(AM_V_at)$(MAKE) news-check
1433 $(AM_V_at)$(MAKE) distcheck
1434 $(AM_V_at)$(MAKE) dist
1435 $(AM_V_at)$(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1436 $(AM_V_at)$(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1438 release:
1439 $(AM_V_GEN)$(MAKE) _version
1440 $(AM_V_GEN)$(MAKE) $(release-type)
1442 # Override this in cfg.mk if you follow different procedures.
1443 release-prep-hook ?= release-prep
1445 gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
1446 .PHONY: release-prep
1447 release-prep:
1448 $(AM_V_GEN)$(MAKE) --no-print-directory -s announcement \
1449 > ~/announce-$(my_distdir)
1450 $(AM_V_at)if test -d $(release_archive_dir); then \
1451 ln $(rel-files) $(release_archive_dir); \
1452 chmod a-w $(rel-files); \
1454 $(AM_V_at)echo $(VERSION) > $(prev_version_file)
1455 $(AM_V_at)$(MAKE) update-NEWS-hash
1456 $(AM_V_at)perl -pi \
1457 -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' \
1458 $(srcdir)/NEWS
1459 $(AM_V_at)msg=$$($(emit-commit-log)) || exit 1; \
1460 cd $(srcdir) && $(VC) commit -m "$$msg" -a
1462 # Override this with e.g., -s $(srcdir)/some_other_name.texi
1463 # if the default $(PACKAGE)-derived name doesn't apply.
1464 gendocs_options_ ?=
1466 .PHONY: web-manual
1467 web-manual:
1468 $(AM_V_GEN)test -z "$(manual_title)" \
1469 && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1470 $(AM_V_at)cd '$(srcdir)/doc'; \
1471 $(SHELL) ../$(_build-aux)/gendocs.sh $(gendocs_options_) \
1472 -o '$(abs_builddir)/doc/manual' \
1473 --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1474 "$(PACKAGE_NAME) - $(manual_title)"
1475 $(AM_V_at)echo " *** Upload the doc/manual directory to web-cvs."
1477 .PHONY: web-manual-update
1478 web-manual-update:
1479 $(AM_V_GEN)cd $(srcdir) \
1480 && $(_build-aux)/gnu-web-doc-update -C $(abs_builddir)
1483 # Code Coverage
1485 init-coverage:
1486 $(MAKE) $(AM_MAKEFLAGS) clean
1487 lcov --directory . --zerocounters
1489 COVERAGE_CCOPTS ?= "-g --coverage"
1490 COVERAGE_OUT ?= doc/coverage
1492 build-coverage:
1493 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1494 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1495 mkdir -p $(COVERAGE_OUT)
1496 lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1497 --capture
1499 gen-coverage:
1500 genhtml --output-directory $(COVERAGE_OUT) \
1501 $(COVERAGE_OUT)/$(PACKAGE).info \
1502 --highlight --frames --legend \
1503 --title "$(PACKAGE_NAME)"
1505 coverage:
1506 $(MAKE) init-coverage
1507 $(MAKE) build-coverage
1508 $(MAKE) gen-coverage
1510 # Some projects carry local adjustments for gnulib modules via patches in
1511 # a gnulib patch directory whose default name is gl/ (defined in bootstrap
1512 # via local_gl_dir=gl). Those patches become stale as the originals evolve
1513 # in gnulib. Use this rule to refresh any stale patches. It applies each
1514 # patch to the original in $(gnulib_dir) and uses the temporary result to
1515 # generate a fuzz-free .diff file. If you customize the name of your local
1516 # gnulib patch directory via bootstrap.conf, this rule detects that name.
1517 # Run this from a non-VPATH (i.e., srcdir) build directory.
1518 .PHONY: refresh-gnulib-patches
1519 refresh-gnulib-patches:
1520 gl=gl; \
1521 if test -f bootstrap.conf; then \
1522 t=$$(perl -lne '/^\s*local_gl_dir=(\S+)/ and $$d=$$1;' \
1523 -e 'END{defined $$d and print $$d}' bootstrap.conf); \
1524 test -n "$$t" && gl=$$t; \
1525 fi; \
1526 for diff in $$(cd $$gl; git ls-files | grep '\.diff$$'); do \
1527 b=$$(printf %s "$$diff"|$(SED) 's/\.diff$$//'); \
1528 VERSION_CONTROL=none \
1529 patch "$(gnulib_dir)/$$b" "$$gl/$$diff" || exit 1; \
1530 ( cd $(gnulib_dir) || exit 1; \
1531 git diff "$$b" > "../$$gl/$$diff"; \
1532 git checkout $$b ) || exit 1; \
1533 done
1535 # Update gettext files.
1536 PACKAGE ?= $(shell basename $(PWD))
1537 PO_DOMAIN ?= $(PACKAGE)
1538 POURL = https://translationproject.org/latest/$(PO_DOMAIN)/
1539 PODIR ?= po
1540 refresh-po:
1541 rm -f $(PODIR)/*.po && \
1542 echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1543 wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1544 echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1545 echo 'en@quot' >> $(PODIR)/LINGUAS && \
1546 ls $(PODIR)/*.po | $(SED) 's/\.po//;s,$(PODIR)/,,' | \
1547 sort >> $(PODIR)/LINGUAS
1549 # Running indent once is not idempotent, but running it twice is.
1550 INDENT_SOURCES ?= $(C_SOURCES)
1551 .PHONY: indent
1552 indent:
1553 indent $(INDENT_SOURCES)
1554 indent $(INDENT_SOURCES)
1556 # If you want to set UPDATE_COPYRIGHT_* environment variables,
1557 # put the assignments in this variable.
1558 update-copyright-env ?=
1560 # Run this rule once per year (usually early in January)
1561 # to update all FSF copyright year lists in your project.
1562 # If you have an additional project-specific rule,
1563 # add it in cfg.mk along with a line 'update-copyright: prereq'.
1564 # By default, exclude all variants of COPYING; you can also
1565 # add exemptions (such as ChangeLog..* for rotated change logs)
1566 # in the file .x-update-copyright.
1567 .PHONY: update-copyright
1568 update-copyright:
1569 $(AM_V_GEN)grep -l -w Copyright \
1570 $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
1571 | $(update-copyright-env) xargs $(srcdir)/$(_build-aux)/$@
1573 # This tight_scope test is skipped with a warning if $(_gl_TS_headers) is not
1574 # overridden and $(_gl_TS_dir)/Makefile.am does not mention noinst_HEADERS.
1576 # NOTE: to override any _gl_TS_* default value, you must
1577 # define the variable(s) using "export" in cfg.mk.
1578 _gl_TS_dir ?= src
1580 ALL_RECURSIVE_TARGETS += sc_tight_scope
1581 sc_tight_scope: tight-scope.mk
1582 @fail=0; \
1583 if ! grep '^ *export _gl_TS_headers *=' $(srcdir)/cfg.mk \
1584 > /dev/null \
1585 && ! grep -w noinst_HEADERS $(srcdir)/$(_gl_TS_dir)/Makefile.am \
1586 > /dev/null 2>&1; then \
1587 echo '$(ME): skipping $@'; \
1588 else \
1589 $(MAKE) -s -C $(_gl_TS_dir) \
1590 -f Makefile \
1591 -f $(abs_top_srcdir)/cfg.mk \
1592 -f $(abs_top_builddir)/$< \
1593 _gl_tight_scope \
1594 || fail=1; \
1595 fi; \
1596 rm -f $<; \
1597 exit $$fail
1599 tight-scope.mk: $(ME)
1600 @rm -f $@ $@-t
1601 @perl -ne '/^# TS-start/.../^# TS-end/ and print' $(srcdir)/$(ME) > $@-t
1602 @chmod a=r $@-t && mv $@-t $@
1604 ifeq (a,b)
1605 # TS-start
1607 # Most functions should have static scope.
1608 # Any that don't must be marked with 'extern', but 'main'
1609 # and 'usage' are exceptions: they're always extern, but
1610 # do not need to be marked. Symbols matching '__.*' are
1611 # reserved by the compiler, so are automatically excluded below.
1612 _gl_TS_unmarked_extern_functions ?= main usage
1613 _gl_TS_function_match ?= /^(?:$(_gl_TS_extern)) +.*?(\w+) *\(/
1615 # If your project uses a macro like "XTERN", then put
1616 # the following in cfg.mk to override this default:
1617 # export _gl_TS_extern = extern|XTERN
1618 _gl_TS_extern ?= extern
1620 # The second nm|grep checks for file-scope variables with 'extern' scope.
1621 # Without gnulib's progname module, you might put program_name here.
1622 # Symbols matching '__.*' are reserved by the compiler,
1623 # so are automatically excluded below.
1624 _gl_TS_unmarked_extern_vars ?=
1626 # NOTE: the _match variables are perl expressions -- not mere regular
1627 # expressions -- so that you can extend them to match other patterns
1628 # and easily extract matched variable names.
1629 # For example, if your project declares some global variables via
1630 # a macro like this: GLOBAL(type, var_name, initializer), then you
1631 # can override this definition to automatically extract those names:
1632 # export _gl_TS_var_match = \
1633 # /^(?:$(_gl_TS_extern)) .*?\**(\w+)(\[.*?\])?;/ || /\bGLOBAL\(.*?,\s*(.*?),/
1634 _gl_TS_var_match ?= /^(?:$(_gl_TS_extern)) .*?(\w+)(\[.*?\])?;/
1636 # The names of object files in (or relative to) $(_gl_TS_dir).
1637 _gl_TS_obj_files ?= *.$(OBJEXT)
1639 # Files in which to search for the one-line style extern declarations.
1640 # $(_gl_TS_dir)-relative.
1641 _gl_TS_headers ?= $(noinst_HEADERS)
1642 _gl_TS_other_headers ?= *.h
1644 .PHONY: _gl_tight_scope
1645 _gl_tight_scope: $(bin_PROGRAMS)
1646 sed_wrap='s/^/^_?/;s/$$/$$/'; \
1647 t=exceptions-$$$$; \
1648 trap 's=$$?; rm -f $$t; exit $$s' 0; \
1649 for sig in 1 2 3 13 15; do \
1650 eval "trap 'v=`expr $$sig + 128`; (exit $$v); exit $$v' $$sig"; \
1651 done; \
1652 src=`for f in $(SOURCES); do \
1653 test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
1654 hdr=`for f in $(_gl_TS_headers); do \
1655 test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
1656 ( printf '%s\n' '__.*' $(_gl_TS_unmarked_extern_functions); \
1657 grep -h -A1 '^extern .*[^;]$$' $$src \
1658 | grep -vE '^(extern |--|#)' | $(SED) 's/ .*//; /^$$/d'; \
1659 perl -lne \
1660 '$(_gl_TS_function_match) and print $$1' $$hdr; \
1661 ) | sort -u | $(SED) "$$sed_wrap" > $$t; \
1662 nm -g $(_gl_TS_obj_files)|$(SED) -n 's/.* T //p'|grep -Ev -f $$t \
1663 && { echo the above functions should have static scope >&2; \
1664 exit 1; } || : ; \
1665 ( printf '%s\n' '__.*' main $(_gl_TS_unmarked_extern_vars); \
1666 perl -lne '$(_gl_TS_var_match) and print $$1' \
1667 $$hdr $(_gl_TS_other_headers) \
1668 ) | sort -u | $(SED) "$$sed_wrap" > $$t; \
1669 nm -g $(_gl_TS_obj_files) | $(SED) -n 's/.* [BCDGRS] //p' \
1670 | sort -u | grep -Ev -f $$t \
1671 && { echo the above variables should have static scope >&2; \
1672 exit 1; } || :
1673 # TS-end
1674 endif